%% Example for DCT transform

image = double(imread('cameraman.tif'));
figure; imshow(image,[]);
title('Original image', 'FontSize', 16);

dct_coef = dct2(image);
figure; imshow(abs(dct_coef),[0,300]);
title('DCT coefficients', 'FontSize', 16);

thre = 15;
dct_coef_thre = dct_coef.*(abs(dct_coef)>thre);
image_comp = idct2(dct_coef_thre);
figure; imshow(image_comp,[]);
comp_ratio = sum(dct_coef(:)~=0)/sum(dct_coef_thre(:)~=0);
title(sprintf('Compressed image (using DCT, ratio=%1.1f)',comp_ratio), 'FontSize',16)
